Index: binaries/data/mods/public/gui/session/menu.js
===================================================================
--- binaries/data/mods/public/gui/session/menu.js	(Revision 14461)
+++ binaries/data/mods/public/gui/session/menu.js	(Arbeitskopie)
@@ -45,7 +45,7 @@
 // Ignore size defined in XML and set the actual menu size here
 function initMenuPosition()
 {
-	menu = getGUIObjectByName("menu");
+	menu = Engine.GetGUIObjectByName("menu");
 	menu.size = INITIAL_MENU_POSITION;
 }
 
@@ -153,20 +153,21 @@
 	messageBox(400, 200, "Are you sure you want to quit?", "Confirmation", 0, btCaptions, btCode);
 }
 
+
 function openDeleteDialog(selection)
 {
 	closeMenu();
 	closeOpenDialogs();
 
-	var deleteSelectedEntities = function ()
+	var deleteSelectedEntities = function (selectionArg)
 	{
-		Engine.PostNetworkCommand({"type": "delete-entities", "entities": selection});
+		Engine.PostNetworkCommand({"type": "delete-entities", "entities": selectionArg});
 	};
 
 	var btCaptions = ["Yes", "No"];
 	var btCode = [deleteSelectedEntities, resumeGame];
 
-	messageBox(400, 200, "Destroy everything currently selected?", "Delete", 0, btCaptions, btCode);
+	messageBox(400, 200, "Destroy everything currently selected?", "Delete", 0, btCaptions, btCode, [selection, null]);
 }
 
 // Menu functions
@@ -182,38 +183,38 @@
 
 function openSettings(pause)
 {
-	getGUIObjectByName("settingsDialogPanel").hidden = false;
+	Engine.GetGUIObjectByName("settingsDialogPanel").hidden = false;
 	if (pause)
 		pauseGame();
 }
 
 function closeSettings(resume)
 {
-	getGUIObjectByName("settingsDialogPanel").hidden = true;
+	Engine.GetGUIObjectByName("settingsDialogPanel").hidden = true;
 	if (resume)
 		resumeGame();
 }
 
 function openChat()
 {
-	getGUIObjectByName("chatInput").focus(); // Grant focus to the input area
-	getGUIObjectByName("chatDialogPanel").hidden = false;
+	Engine.GetGUIObjectByName("chatInput").focus(); // Grant focus to the input area
+	Engine.GetGUIObjectByName("chatDialogPanel").hidden = false;
 
 }
 
 function closeChat()
 {
-	getGUIObjectByName("chatInput").caption = ""; // Clear chat input
-	getGUIObjectByName("chatInput").blur(); // Remove focus
-	getGUIObjectByName("chatDialogPanel").hidden = true;
+	Engine.GetGUIObjectByName("chatInput").caption = ""; // Clear chat input
+	Engine.GetGUIObjectByName("chatInput").blur(); // Remove focus
+	Engine.GetGUIObjectByName("chatDialogPanel").hidden = true;
 }
 
 function toggleChatWindow(teamChat)
 {
 	closeSettings();
 
-	var chatWindow = getGUIObjectByName("chatDialogPanel");
-	var chatInput = getGUIObjectByName("chatInput");
+	var chatWindow = Engine.GetGUIObjectByName("chatDialogPanel");
+	var chatInput = Engine.GetGUIObjectByName("chatInput");
 
 	if (chatWindow.hidden)
 		chatInput.focus(); // Grant focus to the input area
@@ -227,7 +228,7 @@
 		chatInput.caption = ""; // Clear chat input
 	}
 
-	getGUIObjectByName("toggleTeamChat").checked = teamChat;
+	Engine.GetGUIObjectByName("toggleTeamChat").checked = teamChat;
 	chatWindow.hidden = !chatWindow.hidden;
 }
 
@@ -251,14 +252,14 @@
 	var players = getPlayerData(g_PlayerAssignments);
 
 	// Get offset for one line
-	var onesize = getGUIObjectByName("diplomacyPlayer[0]").size;
+	var onesize = Engine.GetGUIObjectByName("diplomacyPlayer[0]").size;
 	var rowsize = onesize.bottom - onesize.top;
 
 	// We don't include gaia
 	for (var i = 1; i < players.length; i++)
 	{
 		// Apply offset
-		var row = getGUIObjectByName("diplomacyPlayer["+(i-1)+"]");
+		var row = Engine.GetGUIObjectByName("diplomacyPlayer["+(i-1)+"]");
 		var size = row.size;
 		size.top = rowsize*(i-1);
 		size.bottom = rowsize*i;
@@ -268,27 +269,27 @@
 		var playerColor = players[i].color.r+" "+players[i].color.g+" "+players[i].color.b;
 		row.sprite = "colour: "+playerColor + " 32";
 
-		getGUIObjectByName("diplomacyPlayerName["+(i-1)+"]").caption = "[color=\"" + playerColor + "\"]" + players[i].name + "[/color]";
-		getGUIObjectByName("diplomacyPlayerCiv["+(i-1)+"]").caption = g_CivData[players[i].civ].Name;
+		Engine.GetGUIObjectByName("diplomacyPlayerName["+(i-1)+"]").caption = "[color=\"" + playerColor + "\"]" + players[i].name + "[/color]";
+		Engine.GetGUIObjectByName("diplomacyPlayerCiv["+(i-1)+"]").caption = g_CivData[players[i].civ].Name;
 
-		getGUIObjectByName("diplomacyPlayerTeam["+(i-1)+"]").caption = (players[i].team < 0) ? "None" : players[i].team+1;
+		Engine.GetGUIObjectByName("diplomacyPlayerTeam["+(i-1)+"]").caption = (players[i].team < 0) ? "None" : players[i].team+1;
 
 		if (i != we)
-			getGUIObjectByName("diplomacyPlayerTheirs["+(i-1)+"]").caption = (players[i].isAlly[we] ? "Ally" : (players[i].isNeutral[we] ? "Neutral" : "Enemy"));
+			Engine.GetGUIObjectByName("diplomacyPlayerTheirs["+(i-1)+"]").caption = (players[i].isAlly[we] ? "Ally" : (players[i].isNeutral[we] ? "Neutral" : "Enemy"));
 
 		// Don't display the options for ourself, or if we or the other player aren't active anymore
 		if (i == we || players[we].state != "active" || players[i].state != "active")
 		{
 			// Hide the unused/unselectable options
 			for each (var a in ["TributeFood", "TributeWood", "TributeStone", "TributeMetal", "Ally", "Neutral", "Enemy"])
-				getGUIObjectByName("diplomacyPlayer"+a+"["+(i-1)+"]").hidden = true;
+				Engine.GetGUIObjectByName("diplomacyPlayer"+a+"["+(i-1)+"]").hidden = true;
 			continue;
 		}
 
 		// Tribute
 		for each (var resource in ["food", "wood", "stone", "metal"])
 		{
-			var button = getGUIObjectByName("diplomacyPlayerTribute"+toTitleCase(resource)+"["+(i-1)+"]");
+			var button = Engine.GetGUIObjectByName("diplomacyPlayerTribute"+toTitleCase(resource)+"["+(i-1)+"]");
 			button.onpress = (function(player, resource, button){
 				// Implement something like how unit batch training works. Shift+click to send 500, shift+click+click to send 1000, etc.
 				// Also see input.js (searching for "INPUT_MASSTRIBUTING" should get all the relevant parts).
@@ -330,7 +331,7 @@
 		// Set up the buttons
 		for each (var setting in ["ally", "neutral", "enemy"])
 		{
-			var button = getGUIObjectByName("diplomacyPlayer"+toTitleCase(setting)+"["+(i-1)+"]");
+			var button = Engine.GetGUIObjectByName("diplomacyPlayer"+toTitleCase(setting)+"["+(i-1)+"]");
 
 			if (setting == "ally")
 			{
@@ -359,13 +360,13 @@
 		}
 	}
 
-	getGUIObjectByName("diplomacyDialogPanel").hidden = false;
+	Engine.GetGUIObjectByName("diplomacyDialogPanel").hidden = false;
 }
 
 function closeDiplomacy()
 {
 	isDiplomacyOpen = false;
-	getGUIObjectByName("diplomacyDialogPanel").hidden = true;
+	Engine.GetGUIObjectByName("diplomacyDialogPanel").hidden = true;
 }
 
 function toggleDiplomacy()
@@ -409,24 +410,24 @@
 	var selec = RESOURCES[0];
 	for (var i = 0; i < RESOURCES.length; ++i)
 	{
-		var buttonResource = getGUIObjectByName("tradeResource["+i+"]");
+		var buttonResource = Engine.GetGUIObjectByName("tradeResource["+i+"]");
 		if (i > 0)
 		{
-			var size = getGUIObjectByName("tradeResource["+(i-1)+"]").size;
+			var size = Engine.GetGUIObjectByName("tradeResource["+(i-1)+"]").size;
 			var width = size.right - size.left;
 			size.left += width;
 			size.right += width;
-			getGUIObjectByName("tradeResource["+i+"]").size = size;
+			Engine.GetGUIObjectByName("tradeResource["+i+"]").size = size;
 		}
 		var resource = RESOURCES[i];
 		proba[resource] = (proba[resource] ? proba[resource] : 0);
-		var buttonResource = getGUIObjectByName("tradeResourceButton["+i+"]");
-		var icon = getGUIObjectByName("tradeResourceIcon["+i+"]");
+		var buttonResource = Engine.GetGUIObjectByName("tradeResourceButton["+i+"]");
+		var icon = Engine.GetGUIObjectByName("tradeResourceIcon["+i+"]");
 		icon.sprite = "stretched:session/icons/resources/" + resource + ".png";
-		var label = getGUIObjectByName("tradeResourceText["+i+"]");
-		var buttonUp = getGUIObjectByName("tradeArrowUp["+i+"]");
-		var buttonDn = getGUIObjectByName("tradeArrowDn["+i+"]");
-		var iconSel = getGUIObjectByName("tradeResourceSelection["+i+"]");
+		var label = Engine.GetGUIObjectByName("tradeResourceText["+i+"]");
+		var buttonUp = Engine.GetGUIObjectByName("tradeArrowUp["+i+"]");
+		var buttonDn = Engine.GetGUIObjectByName("tradeArrowDn["+i+"]");
+		var iconSel = Engine.GetGUIObjectByName("tradeResourceSelection["+i+"]");
 		button[resource] = { "res": buttonResource, "up": buttonUp, "dn": buttonDn, "label": label, "sel": iconSel };
 
 		buttonResource.onpress = (function(resource){
@@ -479,7 +480,7 @@
 		if (inactive > 0)
 			caption += comma + "[color=\"orange\"]" + inactive + " inactive[/color]";
 	}
-	getGUIObjectByName("landTraders").caption = caption;
+	Engine.GetGUIObjectByName("landTraders").caption = caption;
 
 	caption = "";
 	comma = "";
@@ -496,15 +497,15 @@
 		if (inactive > 0)
 			caption += comma + "[color=\"orange\"]" + inactive + " inactive[/color]";
 	}
-	getGUIObjectByName("shipTraders").caption = caption;
+	Engine.GetGUIObjectByName("shipTraders").caption = caption;
 
-	getGUIObjectByName("tradeDialogPanel").hidden = false;
+	Engine.GetGUIObjectByName("tradeDialogPanel").hidden = false;
 }
 
 function closeTrade()
 {
 	isTradeOpen = false;
-	getGUIObjectByName("tradeDialogPanel").hidden = true;
+	Engine.GetGUIObjectByName("tradeDialogPanel").hidden = true;
 }
 
 function toggleTrade()
@@ -517,22 +518,22 @@
 
 function toggleGameSpeed()
 {
-	var gameSpeed = getGUIObjectByName("gameSpeed");
+	var gameSpeed = Engine.GetGUIObjectByName("gameSpeed");
 	gameSpeed.hidden = !gameSpeed.hidden;
 }
 
 function pauseGame()
 {
-	getGUIObjectByName("pauseButtonText").caption = RESUME;
-	getGUIObjectByName("pauseOverlay").hidden = false;
-	setPaused(true);
+	Engine.GetGUIObjectByName("pauseButtonText").caption = RESUME;
+	Engine.GetGUIObjectByName("pauseOverlay").hidden = false;
+	Engine.SetPaused(true);
 }
 
 function resumeGame()
 {
-	getGUIObjectByName("pauseButtonText").caption = PAUSE;
-	getGUIObjectByName("pauseOverlay").hidden = true;
-	setPaused(false);
+	Engine.GetGUIObjectByName("pauseButtonText").caption = PAUSE;
+	Engine.GetGUIObjectByName("pauseOverlay").hidden = true;
+	Engine.SetPaused(false);
 }
 
 function togglePause()
@@ -540,17 +541,17 @@
 	closeMenu();
 	closeOpenDialogs();
 
-	var pauseOverlay = getGUIObjectByName("pauseOverlay");
+	var pauseOverlay = Engine.GetGUIObjectByName("pauseOverlay");
 
 	if (pauseOverlay.hidden)
 	{
-		getGUIObjectByName("pauseButtonText").caption = RESUME;
-		setPaused(true);
+		Engine.GetGUIObjectByName("pauseButtonText").caption = RESUME;
+		Engine.SetPaused(true);
 	}
 	else
 	{
-		setPaused(false);
-		getGUIObjectByName("pauseButtonText").caption = PAUSE;
+		Engine.SetPaused(false);
+		Engine.GetGUIObjectByName("pauseButtonText").caption = PAUSE;
 	}
 
 	pauseOverlay.hidden = !pauseOverlay.hidden;
@@ -569,11 +570,11 @@
 	if (Engine.HasXmppClient() && Engine.IsRankedGame())
 		return;
 
-	var devCommands = getGUIObjectByName("devCommands");
+	var devCommands = Engine.GetGUIObjectByName("devCommands");
 	var text = devCommands.hidden ? "opened." : "closed.";
 	submitChatDirectly("The Developer Overlay was " + text);
 	// Update the options dialog
-	getGUIObjectByName("developerOverlayCheckbox").checked = devCommands.hidden;
+	Engine.GetGUIObjectByName("developerOverlayCheckbox").checked = devCommands.hidden;
 	devCommands.hidden = !devCommands.hidden;
 }
 
Index: binaries/data/mods/public/gui/session/messages.js
===================================================================
--- binaries/data/mods/public/gui/session/messages.js	(Revision 14461)
+++ binaries/data/mods/public/gui/session/messages.js	(Arbeitskopie)
@@ -136,12 +136,12 @@
 	var messages = [];
 	for each (var n in notifications)
 		messages.push(n.message);
-	getGUIObjectByName("notificationText").caption = messages.join("\n");
+	Engine.GetGUIObjectByName("notificationText").caption = messages.join("\n");
 }
 
 function updateTimeNotifications()
 {
-	getGUIObjectByName("timeNotificationText").caption = Engine.GuiInterfaceCall("GetTimeNotificationText");
+	Engine.GetGUIObjectByName("timeNotificationText").caption = Engine.GuiInterfaceCall("GetTimeNotificationText");
 }
 
 // Returns [username, playercolor] for the given player
@@ -167,7 +167,7 @@
 		if (g_Disconnected)
 			return;
 
-		var obj = getGUIObjectByName("netStatus");
+		var obj = Engine.GetGUIObjectByName("netStatus");
 		switch (message.status)
 		{
 		case "waiting_for_players":
@@ -265,7 +265,7 @@
 
 function submitChatInput()
 {
-	var input = getGUIObjectByName("chatInput");
+	var input = Engine.GetGUIObjectByName("chatInput");
 	var text = input.caption;
 	var isCheat = false;
 	if (text.length)
@@ -305,7 +305,7 @@
 
 		if (!isCheat)
 		{
-			if (getGUIObjectByName("toggleTeamChat").checked)
+			if (Engine.GetGUIObjectByName("toggleTeamChat").checked)
 				text = "/team " + text;
 
 			if (g_IsNetworked)
@@ -443,7 +443,7 @@
 	if (chatMessages.length > MAX_NUM_CHAT_LINES)
 		removeOldChatMessages();
 	else
-		getGUIObjectByName("chatText").caption = chatMessages.join("\n");
+		Engine.GetGUIObjectByName("chatText").caption = chatMessages.join("\n");
 }
 
 function removeOldChatMessages()
@@ -451,7 +451,7 @@
 	clearTimeout(chatTimers[0]); // The timer only needs to be cleared when new messages bump old messages off
 	chatTimers.shift();
 	chatMessages.shift();
-	getGUIObjectByName("chatText").caption = chatMessages.join("\n");
+	Engine.GetGUIObjectByName("chatText").caption = chatMessages.join("\n");
 }
 
 // Parses chat messages for commands.
Index: binaries/data/mods/public/gui/session/session.js
===================================================================
--- binaries/data/mods/public/gui/session/session.js	(Revision 14461)
+++ binaries/data/mods/public/gui/session/session.js	(Arbeitskopie)
@@ -137,7 +137,7 @@
 		if (initData.savedGUIData)
 			restoreSavedGameData(initData.savedGUIData);
 
-		getGUIObjectByName("gameSpeedButton").hidden = g_IsNetworked;
+		Engine.GetGUIObjectByName("gameSpeedButton").hidden = g_IsNetworked;
 	}
 	else // Needed for autostart loading option
 	{
@@ -150,15 +150,15 @@
 
 	g_GameSpeeds = initGameSpeeds();
 	g_CurrentSpeed = Engine.GetSimRate();
-	var gameSpeed = getGUIObjectByName("gameSpeed");
+	var gameSpeed = Engine.GetGUIObjectByName("gameSpeed");
 	gameSpeed.list = g_GameSpeeds.names;
 	gameSpeed.list_data = g_GameSpeeds.speeds;
 	var idx = g_GameSpeeds.speeds.indexOf(g_CurrentSpeed);
 	gameSpeed.selected = idx != -1 ? idx : g_GameSpeeds["default"];
 	gameSpeed.onSelectionChange = function() { changeGameSpeed(+this.list_data[this.selected]); }
 
-	getGUIObjectByName("civIcon").sprite = "stretched:" + g_CivData[g_Players[Engine.GetPlayerID()].civ].Emblem;
-	getGUIObjectByName("civIcon").tooltip = g_CivData[g_Players[Engine.GetPlayerID()].civ].Name;
+	Engine.GetGUIObjectByName("civIcon").sprite = "stretched:" + g_CivData[g_Players[Engine.GetPlayerID()].civ].Emblem;
+	Engine.GetGUIObjectByName("civIcon").tooltip = g_CivData[g_Players[Engine.GetPlayerID()].civ].Name;
 	initMenuPosition(); // set initial position
 
 	// Populate player selection dropdown
@@ -170,14 +170,14 @@
 		playerIDs.push(player);
 	}
 
-	var viewPlayerDropdown = getGUIObjectByName("viewPlayer");
+	var viewPlayerDropdown = Engine.GetGUIObjectByName("viewPlayer");
 	viewPlayerDropdown.list = playerNames;
 	viewPlayerDropdown.list_data = playerIDs;
 	viewPlayerDropdown.selected = Engine.GetPlayerID();
 
 	// If in Atlas editor, disable the exit button
 	if (Engine.IsAtlasRunning())
-		getGUIObjectByName("menuExitButton").enabled = false;
+		Engine.GetGUIObjectByName("menuExitButton").enabled = false;
 
 	if (hotloadData)
 	{
@@ -194,7 +194,7 @@
 	}
 
 	if (Engine.ConfigDB_GetValue("user", "gui.session.timeelapsedcounter") === "true")
-		getGUIObjectByName("timeElapsedCounter").hidden = false;
+		Engine.GetGUIObjectByName("timeElapsedCounter").hidden = false;
 
 	onSimulationUpdate();
 
@@ -210,8 +210,8 @@
 {
 	Engine.SetPlayerID(playerID);
 	if (playerID != 0) {
-		getGUIObjectByName("civIcon").sprite = "stretched:" + g_CivData[g_Players[playerID].civ].Emblem;
-		getGUIObjectByName("civIcon").tooltip = g_CivData[g_Players[playerID].civ].Name;
+		Engine.GetGUIObjectByName("civIcon").sprite = "stretched:" + g_CivData[g_Players[playerID].civ].Emblem;
+		Engine.GetGUIObjectByName("civIcon").tooltip = g_CivData[g_Players[playerID].civ].Name;
 	}
 }
 
@@ -280,7 +280,7 @@
 	}
 
 	stopAmbient();
-	endGame();
+	Engine.EndGame();
 
 	if (g_IsController && Engine.HasXmppClient())
 		Engine.SendUnregisterGame();
@@ -367,9 +367,9 @@
 
 	// When training is blocked, flash population (alternates colour every 500msec)
 	if (g_IsTrainingBlocked && (Date.now() % 1000) < 500)
-		getGUIObjectByName("resourcePop").textcolor = POPULATION_ALERT_COLOR;
+		Engine.GetGUIObjectByName("resourcePop").textcolor = POPULATION_ALERT_COLOR;
 	else
-		getGUIObjectByName("resourcePop").textcolor = DEFAULT_POPULATION_COLOR;
+		Engine.GetGUIObjectByName("resourcePop").textcolor = DEFAULT_POPULATION_COLOR;
 
 	// Clear renamed entities list
 	Engine.GuiInterfaceCall("ClearRenamedEntities");
@@ -398,7 +398,7 @@
 		return;
 
 	// We can't resign once the game is over.
-	getGUIObjectByName("menuResignButton").enabled = false;
+	Engine.GetGUIObjectByName("menuResignButton").enabled = false;
 
 	// Make sure nothing is open to avoid stacking.
 	closeMenu();
@@ -430,8 +430,8 @@
 	{
 		global.music.setState(global.music.states.VICTORY);
 		// TODO: Reveal map directly instead of this silly proxy.
-		if (!getGUIObjectByName("devCommandsRevealMap").checked)
-			getGUIObjectByName("devCommandsRevealMap").checked = true;
+		if (!Engine.GetGUIObjectByName("devCommandsRevealMap").checked)
+			Engine.GetGUIObjectByName("devCommandsRevealMap").checked = true;
 		messageBox(400, 200, message, "VICTORIOUS!", 0, btCaptions, btCode);
 	}
 
@@ -491,7 +491,7 @@
 {
 	var simState = GetSimState();
 	var playerState = simState.players[Engine.GetPlayerID()];
-	var heroButton = getGUIObjectByName("unitHeroButton");
+	var heroButton = Engine.GetGUIObjectByName("unitHeroButton");
 
 	if (!playerState || playerState.heroes.length <= 0)
 	{
@@ -499,7 +499,7 @@
 		return;
 	}
 
-	var heroImage = getGUIObjectByName("unitHeroImage");
+	var heroImage = Engine.GetGUIObjectByName("unitHeroImage");
 	var heroState = GetExtendedEntityState(playerState.heroes[0]);
 	var template = GetTemplateData(heroState.template);
 	heroImage.sprite = "stretched:session/portraits/" + template.icon;
@@ -535,8 +535,8 @@
 	g_Groups.update();
 	for (var i = 0; i < 10; i++)
 	{
-		var button = getGUIObjectByName("unit"+guiName+"Button["+i+"]");
-		var label = getGUIObjectByName("unit"+guiName+"Label["+i+"]").caption = i;
+		var button = Engine.GetGUIObjectByName("unit"+guiName+"Button["+i+"]");
+		var label = Engine.GetGUIObjectByName("unit"+guiName+"Label["+i+"]").caption = i;
 		if (g_Groups.groups[i].getTotalCount() == 0)
 			button.hidden = true;
 		else
@@ -547,7 +547,7 @@
 	var numButtons = i;
 	var rowLength = 1;
 	var numRows = Math.ceil(numButtons / rowLength);
-	var buttonSideLength = getGUIObjectByName("unit"+guiName+"Button[0]").size.bottom;
+	var buttonSideLength = Engine.GetGUIObjectByName("unit"+guiName+"Button[0]").size.bottom;
 	var buttonSpacer = buttonSideLength+1;
 	for (var i = 0; i < numRows; i++)
 		layoutButtonRow(i, guiName, buttonSideLength, buttonSpacer, rowLength*i, rowLength*(i+1) );
@@ -556,9 +556,9 @@
 function updateDebug()
 {
 	var simState = GetSimState();
-	var debug = getGUIObjectByName("debug");
+	var debug = Engine.GetGUIObjectByName("debug");
 
-	if (getGUIObjectByName("devDisplayState").checked)
+	if (Engine.GetGUIObjectByName("devDisplayState").checked)
 	{
 		debug.hidden = false;
 	}
@@ -596,11 +596,11 @@
 	if (!playerState)
 		return;
 
-	getGUIObjectByName("resourceFood").caption = playerState.resourceCounts.food;
-	getGUIObjectByName("resourceWood").caption = playerState.resourceCounts.wood;
-	getGUIObjectByName("resourceStone").caption = playerState.resourceCounts.stone;
-	getGUIObjectByName("resourceMetal").caption = playerState.resourceCounts.metal;
-	getGUIObjectByName("resourcePop").caption = playerState.popCount + "/" + playerState.popLimit;
+	Engine.GetGUIObjectByName("resourceFood").caption = playerState.resourceCounts.food;
+	Engine.GetGUIObjectByName("resourceWood").caption = playerState.resourceCounts.wood;
+	Engine.GetGUIObjectByName("resourceStone").caption = playerState.resourceCounts.stone;
+	Engine.GetGUIObjectByName("resourceMetal").caption = playerState.resourceCounts.metal;
+	Engine.GetGUIObjectByName("resourcePop").caption = playerState.popCount + "/" + playerState.popLimit;
 
 	g_IsTrainingBlocked = playerState.trainingBlocked;
 }
@@ -625,10 +625,10 @@
 		return;
 
 	// Set up initial positioning.
-	var buttonSideLength = getGUIObjectByName("researchStartedButton[0]").size.right;
+	var buttonSideLength = Engine.GetGUIObjectByName("researchStartedButton[0]").size.right;
 	for (var i = 0; i < 10; ++i)
 	{
-		var button = getGUIObjectByName("researchStartedButton[" + i + "]");
+		var button = Engine.GetGUIObjectByName("researchStartedButton[" + i + "]");
 		var size = button.size;
 		size.top = (4 + buttonSideLength) * i;
 		size.bottom = size.top + buttonSideLength;
@@ -643,34 +643,34 @@
 			break;
 
 		var template = GetTechnologyData(tech);
-		var button = getGUIObjectByName("researchStartedButton[" + numButtons + "]");
+		var button = Engine.GetGUIObjectByName("researchStartedButton[" + numButtons + "]");
 		button.hidden = false;
 		button.tooltip = getEntityNames(template);
 		button.onpress = (function(e) { return function() { selectAndMoveTo(e) } })(researchStarted[tech].researcher);
 
 		var icon = "stretched:session/portraits/" + template.icon;
-		getGUIObjectByName("researchStartedIcon[" + numButtons + "]").sprite = icon;
+		Engine.GetGUIObjectByName("researchStartedIcon[" + numButtons + "]").sprite = icon;
 
 		// Scale the progress indicator.
-		var size = getGUIObjectByName("researchStartedProgressSlider[" + numButtons + "]").size;
+		var size = Engine.GetGUIObjectByName("researchStartedProgressSlider[" + numButtons + "]").size;
 
 		// Buttons are assumed to be square, so left/right offsets can be used for top/bottom.
 		size.top = size.left + Math.round(researchStarted[tech].progress * (size.right - size.left));
-		getGUIObjectByName("researchStartedProgressSlider[" + numButtons + "]").size = size;
+		Engine.GetGUIObjectByName("researchStartedProgressSlider[" + numButtons + "]").size = size;
 
 		++numButtons;
 	}
 
 	// Hide unused buttons.
 	for (var i = numButtons; i < 10; ++i)
-		getGUIObjectByName("researchStartedButton[" + i + "]").hidden = true;
+		Engine.GetGUIObjectByName("researchStartedButton[" + i + "]").hidden = true;
 }
 
 function updateTimeElapsedCounter()
 {
 	var simState = GetSimState();
 	var speed = g_CurrentSpeed != 1.0 ? " (" + g_CurrentSpeed + "x)" : "";
-	var timeElapsedCounter = getGUIObjectByName("timeElapsedCounter");
+	var timeElapsedCounter = Engine.GetGUIObjectByName("timeElapsedCounter");
 	timeElapsedCounter.caption = timeToString(simState.timeElapsed) + speed;
 }
 
